<template lang="pug">
  .sswitcher
    b-modal(
      :active="active"
      :width="600"
      @update:active="updateActive"
    )
      .bg-white.ba.b--moon-gray.br2
        .sswitcher__p0.mw5.center.pa2(v-if="page === 0")
          .mv3
            state-tag(:value="stateName")
          .sswitcher__next.bb.b--moon-gray.relative
            b-icon(icon="arrow-alt-circle-down")
          .mv3.pointer.dim(
            v-for="otherState in otherStates"
            :key="otherState.id"
            @click="toState(otherState)"
          )
            state-tag(:value="otherState" :showExternal="true")
        .sswitcher__p1(v-if="page === 1")
          h3.pv3.f4.b.tc.bb.b--moon-gray 選擇切換至「{{nextState.internalState}}」的通知訊息
          .pa3.bb.b--moon-gray.gray.dim.pointer(
            v-for="(text, i) in cannedMsg"
            :key="i"
            @click="chooseText(text)"
          ) {{text}}
          .pa3.pb0
            textarea.w-100.pa2.h4.b-black(
              v-model="msg"
              placeholder="點選上方文字，直接填入罐頭訊息"
            )
          .flex.justify-around.pa3
            b-button(@click="reset") 上一步
            b-button(type="is-primary" @click="changeState" :disabled="!msg")
              | 發送訊息，並切換至
              strong {{nextState.internalState}}

</template>
<script>
import { macro, issue } from '~/utils/api'
import StateTag from '~/components/StateTag'
import { issueMixin } from '~/utils/mixins'

export default {
  components: {
    StateTag
  },
  mixins: [issueMixin],
  props: {
    active: {
      type: Boolean,
      default: false
    },
    itemId: {
      type: String,
      required: true
    },
    stateName: {
      type: String,
      required: true
    }
  },
  data () {
    return {
      availableStates: [],
      generalCannedMsg: [],
      page: 0,
      nextState: null,
      msg: ''
    }
  },
  computed: {
    otherStates () {
      return this.availableStates.filter(state => state.internalState !== this.stateName)
    },
    cannedMsg () {
      if (this.nextState && this.nextState.cannedMsg.length) {
        return [
          ...this.nextState.cannedMsg,
          ...this.generalCannedMsg
        ]
      }
      return this.generalCannedMsg
    }
  },
  created () {
    this.initStateList()
  },
  methods: {
    async initStateList () {
      const stateMap = await macro.listTicketState()
      const cannedMsg = await macro.listCannedMsg()
      const msgPerState = {}

      cannedMsg.forEach((msg) => {
        const state = msg.state
        if (!msgPerState[state]) {
          msgPerState[state] = []
        }
        msgPerState[state].push(msg.msg)
      })

      this.generalCannedMsg = cannedMsg
        .filter(msg => msg.state === '通用訊息')
        .map(msg => msg.msg)
      this.availableStates = stateMap.map((row) => {
        return {
          ...row,
          cannedMsg: msgPerState[row.internalState] || []
        }
      })
    },
    updateActive (active) {
      this.reset()
      this.$emit('update:active', active)
    },
    toState (state) {
      this.nextState = state
      this.page = 1
    },
    reset () {
      this.page = 0
      this.msg = ''
      this.nextState = null
    },
    chooseText (text) {
      this.msg = text
    },
    async changeState () {
      const msg = this.msg.trim()
      if (!msg) {
        return
      }
      await issue.updateState(this.itemId, this.nextState.internalState, msg)

      this.$emit('changed', {
        state: this.nextState.internalState,
        msg
      })
      this.$emit('update:active', false)
      this.reset()
    }
  }
}
</script>
<style lang="scss" scoped>
.sswitcher {
  &__p0 {
    .state-tag {
      width: 100%;
      height: 4em;
      font-size: 1em;
    }
  }
  &__next {
    height: 0.75em;
    margin-bottom: 1.75em;
    .icon {
      position: absolute;
      left: 50%;
      margin-left: -0.75em;
      background: white;
    }
  }
  &__p1 {
    textarea: {
      resize: none;
    }
  }
}
</style>
